import 'package:fis_measure/interfaces/process/calculators/values.dart';
import 'package:fis_measure/process/calcuators/formulas/urology.dart';
import 'package:fis_measure/process/primitives/combos/two_straightline.dart';
import 'package:fis_measure/process/primitives/straightline.dart';

import 'calculator.dart';

class TwoDistanceCalBase extends Calculator<TwoStraightLine, double> {
  TwoDistanceCalBase(TwoStraightLine ref) : super(ref);

  @override
  void calculate() {
    // TODO: implement calculate
  }
}

class ResidualUrineCal extends Calculator<TwoStraightLine, double> {
  ResidualUrineCal(TwoStraightLine ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final x = _pickChildValue(ref.x);
    final y = _pickChildValue(ref.y);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    if (x != null && y != null) {
      final value = UrologyFormulas.calcRUV(
        x,
        y,
      );
      updateFloatValue(value);
    }
  }

  double? _pickChildValue(StraightLine item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null) {
      return (value as FloatValue).value ?? 0;
    }
    return null;
  }
}
