import 'package:fis_measure/interfaces/date_types/point.dart';
import 'package:fis_measure/interfaces/process/items/item.dart';
import 'package:fis_measure/interfaces/process/items/item_metas.dart';
import 'package:fis_measure/process/items/item.dart';
import 'package:fis_measure/process/items/item_feature.dart';

abstract class CurveAbstract extends MeasureItem<CurveAbstractFeature> {
  bool _isClosed = true;
  CurveAbstract(ItemMeta meta, IMeasureItem? parent) : super(meta, parent);

  bool get isClosed => _isClosed;
  set isClosed(bool val) {
    if (val != _isClosed) {
      _isClosed = val;
    }
  }
}

abstract class CurveAbstractFeature extends MeasureItemFeature {
  double _splineTension = 0.0;
  bool _isClosed = true;

  CurveAbstractFeature(CurveAbstract refItem) : super(refItem) {
    isClosed = refItem.isClosed;
  }

  double get splineTension => _splineTension;
  set splineTension(double val) {
    if (val != _splineTension) {
      _splineTension = val;
    }
  }

  DPoint get startPoint => innerPoints.first;
  DPoint get endPoint => innerPoints.last;

  bool get isClosed => _isClosed;
  set isClosed(bool val) {
    if (val != _isClosed) {
      _isClosed = val;
    }
  }

  /// 接收新坐标
  void adopt(DPoint point) {
    innerPoints.add(point);
  }
}
